#!/usr/bin/perl -w

# NEW CHANNEL ID MAPPER
# CONVERT CHANNEL NAMES INTO RYTEC IDs

## takealug.de
## github.com/sunsettrack4

my %REPLACE=(

    "Das Erste"    => "ARD.de",
    "ZDF"    => "ZDF.de",
    "RTL"    => "RTL.de",
    "SAT.1"    => "Sat1.de",
    "ProSieben"    => "Pro7.de",
    "VOX"    => "Vox.de",
    "kabel eins"    => "Kabel.de",
    "RTL II"    => "RTL2.de",
    "Super RTL"    => "SuperRTL.de",
    "KiKA"    => "Kika.de",
    "3sat"    => "3sat.de",
    "WELT"    => "WELT.de",
    "n-tv"    => "ntv.de",
    "PHOENIX"    => "phoenix.de",
    "Tele 5"    => "Tele5.de",
    "zdf_neo"    => "ZDFneo.de",
    "BR Süd"    => "BR.de",
    "hr"    => "HR.de",
    "MDR Sachsen"    => "MDRSachsen.de",
    "NDR"    => "ndrnds.de",
    "Radio Bremen TV"    => "RadioBremen.de",
    "rbb Berlin"    => "rbbBerlin.de",
    "SR"    => "SRFernsehen.de",
    "SWR BW"    => "SWR.de",
    "SWR RP"    => "SWR-rp.de",
    "WDR"    => "WDR.de",
    "SPORT1"    => "Sport1HD.de",
    "Sky Sport News"    => "SkySportNewsHD.de",
    "ARTE"    => "ARTE.de",
    "ONE"    => "One.de",
    "Anixe"    => "Anixe.de",
    "Comedy Central"    => "ComedyCentral/VIVA.de",
    "Disney Channel"    => "disneychannel.de",
    "DMAX"    => "DMax.de",
    "eoTV"    => "eoTV.de",
    "ProSieben MAXX"    => "ProSiebenMaxx.de",
    "NITRO"    => "RTLNitro.de",
    "RTLplus"    => "RTLPlus.de",
    "SAT.1 GOLD"    => "Sat1Gold.de",
    "Servus TV"    => "ServusHD.de",
    "sixx"    => "Sixx.de",
    "TLC"    => "TLC.de",
    "TOGGO plus"    => "TOGGOplus.de",
    "Zee.One"    => "ZeeOne.de",
    "ARD-alpha"    => "ARD-alpha.de",
    "Bibel TV"    => "BibelTV.de",
    "DW"    => "DeutscheWelleDE.de",
    "EuroN D"    => "EuronewsDE.nws",
    "K TV"    => "KTV.de",
    "kabel eins Doku"    => "KabelEinsDoku.de",
    "N24 Doku"    => "N24Doku.de",
    "tagesschau24"    => "tagesschau24.de",
    "Welt der Wunder"    => "WeltDerWunder.de",
    "ZDFinfo"    => "ZDFinfo.de",
    "Deluxe Music"    => "DeLuxeMusic.de",
    "Viva"    => "ComedyCentral/Viva.de",
    "Nick/MTV+"    => "Nickelodeon.de",
    "MTV"    => "MTVGermany.de",
    "MTV Live"    => "MTVLiveHD.eu",
    "MTV Dance"    => "MTVDance.eu",
    "MTV Brand Neu"    => "MTVBrandNew.nl",
    "MTV Rocks"    => "MTVRocks.eu",
    "MTV Hits"    => "MTVHits.eu",
    "MTV Music 24"    => "MTVMusic.eu",
    "HSE 24"    => "HSE24.de",
    "QVC"    => "QVC.de",
    "sonnenklar.TV"    => "SonnenKlar.de",
    "Magenta Musik 1"    => "MagentaMusik1.de",
    "Magenta Musik 2"    => "MagentaMusik2.de",
    "Magenta Musik 3"    => "MagentaMusik3.de",
    "13TH STREET"    => "13thStreet.de",
    "AXN"    => "AXN.de",
    "Disney Cinemagic"    => "DisneyCinemagic.de",
    "FOX"    => "FOX.de",
    "kabel eins Classics"    => "KabelEinsClassic.de",
    "Kinowelt TV"    => "Kinowelt.de",
    "ProSieben FUN"    => "ProSiebenFun.de",
    "RTL Crime"    => "RTLCrime.de",
    "Syfy"    => "SciFi.de",
    "TNT Comedy"    => "TNTComedy.de",
    "TNT Film"    => "TNTFilm.de",
    "TNT Serie"    => "TNTSerie.de",
    "Universal TV"    => "Universal.de",
    "Baby TV"    => "BabyTV.uk",
    "Boomerang"    => "Boomerang.de",
    "Cartoon Network"    => "CartoonNetwork.de",
    "Disney XD"    => "DisneyXD.de",
    "Disney Junior"    => "DisneyJunior.de",
    "Nick Jr."    => "NickJr.de",
    "BonGusto"    => "BonGusto.de",
    "E! Entertainment"    => "EEntertainment.de",
    "Fashion TV"    => "FashionTV.eu",
    "Heimatkanal"    => "Heimatkanal.de",
    "RTL Passion"    => "RTLPassion.de",
    "Romance TV"    => "Romance.de",
    "RTL Living"    => "RTLLiving.de",
    "SAT.1 emotions"    => "Sat1Comedy.de",
    "Sony Channel"    => "SonyEntertainmentTV.de",
    "wetter.com TV"    => "Wetterfernsehen.de",
    "Animal Planet"    => "AnimalPlanet.de",
    "A&amp;E"    => "AandE.de",
    "Discovery Channel"    => "DiscoveryChannel.de",
    "GEO"    => "GEOTV.de",
    "HISTORY"    => "History.de",
    "National Geographic"    => "NatGeo.de",
    "National Geographic WILD"    => "NatGeoWild.de",
    "Planet"    => "PLANET.de",
    "Spiegel TV Wissen"    => "SpiegelTV.de",
    "auto motor und sport"    => "AutoMotorSport.de",
    "Eurosport 1"    => "Eurosport1.de",
    "Eurosport 2"    => "Eurosport2.de",
    "Eurosport360 HD 1"    => "Eurosport360HD1.de",
    "Eurosport360 HD 2"    => "Eurosport360HD2.de",
    "Eurosport360 HD 3"    => "Eurosport360HD3.de",
    "Eurosport360 HD 4"    => "Eurosport360HD4.de",
    "Eurosport360 HD 5"    => "Eurosport360HD5.de",
    "Eurosport360 HD 6"    => "Eurosport360HD6.de",
    "Eurosport360 HD 7"    => "Eurosport360HD7.de",
    "Eurosport360 HD 8"    => "Eurosport360HD8.de",
    "Eurosport360 HD 9"    => "Eurosport360HD9.de",
    "Extreme Sports"    => "ExtremeSports.de",
    "MOTORVISION.TV"    => "MotorVision.de",
    "SPORT1+"    => "SPORT1Plus.de",
    "eSPORTS1"    => "Sport1US.de",
    "sportdigital"    => "sportdigital.de",
    "RCK TV"    => "RCKTV.de",
    "Trace Urban"    => "TraceUrban.fr",
    "MyTeam TV - Basketball 1"    => "MyTeamTVBasketball1.de",
    "MyTeam TV - Basketball 2"    => "MyTeamTVBasketball2.de",
    "MyTeam TV - Basketball 3"    => "MyTeamTVBasketball3.de",
    "Liveübertragungen der BBL-Spiele 4-9"    => "BBLLive.de",
    "MyTeam TV - Eishockey 1"    => "MyTeamTVEishockey1.de",
    "MyTeam TV - Eishockey 2"    => "MyTeamTVEishockey2.de",
    "MyTeam TV - Eishockey 3"    => "MyTeamTVEishockey3.de",
    "MyTeam TV - Eishockey 4"    => "MyTeamTVEishockey4.de",
    "MyTeam TV - Eishockey 5"    => "MyTeamTVEishockey5.de",
    "MyTeam TV - Eishockey 6"    => "MyTeamTVEishockey6.de",
    "MyTeam TV - Eishockey 7"    => "MyTeamTVEishockey7.de",
    "FC BAYERN.TV LIVE"    => "FCBayernTV.de",
    "Sky Sport Kompakt 1"    => "SkySportKompakt1.de",
    "Sky Sport Kompakt 2"    => "SkySportKompakt2.de",
    "Sky Sport Kompakt 3"    => "SkySportKompakt3.de",
    "Sky Sport Kompakt 4"    => "SkySportKompakt4.de",
    "Sky Sport Kompakt 5"    => "SkySportKompakt5.de",
    "MyTeam TV - Fußball 1"    => "MyTeamTVFussball1.de",
    "MyTeam TV - Fußball 2"    => "MyTeamTVFussball2.de",
    "MyTeam TV - Fußball 3"    => "MyTeamTVFussball3.de",
    "MyTeam TV - Fußball 4"    => "MyTeamTVFussball4.de",
    "MyTeam TV - Fußball 5"    => "MyTeamTVFussball5.de",
    "MyTeam TV - Fußball 6"    => "MyTeamTVFussball6.de",
    "MyTeam TV - Fußball 7"    => "MyTeamTVFussball7.de",
    "Weitere Liveübertragungen der 3. Liga"    => "FussballLiga3.de",
    "ran FIGHTING TV"    => "ranFIGHTING.de",
    "Regio TV"    => "regioTV.de",
    "RNF"    => "RNF.de",
    "RNFplus"    => "RNFplus.de",
    "a.tv"    => "a.tv.de",
    "allgäu.tv"    => "allgaeuTV.de",
    "BR Nord"    => "BRNord.de",
    "Donau TV"    => "DonauTV.de",
    "Franken Fernsehen"    => "FrankenTV.de",
    "intv"    => "intv.de",
    "ISAR TV"    => "ISARTV.de",
    "main.tv"    => "maintv.de",
    "münchen.tv"    => "MunchenTV.de",
    "Oberpfalz TV"    => "OberpfalzTV.de",
    "RFO"    => "Oberbayern.de",
    "SAT.1 Bayern"    => "Sat1Bayern.de",
    "TRP1"    => "TRP1.de",
    "TV Oberfranken"    => "tvo.de",
    "TV Mainfranken Schweinfurt"    => "TVMainfrankenS.de",
    "TV Mainfranken Würzburg"    => "TVMainfrankenW.de",
    "TVA Ostbayern"    => "TVA.de",
    "ALEX Berlin"    => "ALEXberlin.de",
    "Potsdam TV"    => "PotsdamTV.de",
    "tv.berlin"    => "TVBerlin.de",
    "rbb Brandenburg"    => "rbbBrandenburg.de",
    "RTL HB NDS"    => "RTLHBNDS.de",
    "SAT.1 NDS Bremen"    => "Sat1HBNDS.de",
    "Hamburg 1"    => "Hamburg1.de",
    "NDR Hamburg"    => "ndr.de",
    "NDR Schleswig-Holstein"    => "ndrsh.de",
    "RTL HH SH"    => "RTLHHSH.de",
    "SAT.1 HH SH"    => "Sat1HHSH.de",
    "OF-TV"    => "oftv.de",
    "Rhein-Main TV"    => "rheinmaintv.de",
    "RTL Hessen"    => "RTLHessen.de",
    "NDR Mecklenburg-Vorpommern"    => "ndrmv.de",
    "CityVision"    => "CityVision.de",
    "nrwision"    => "nrwision.de",
    "RTL NRW"    => "RTLNRW.de",
    "SAT.1 NRW"    => "Sat1NRW.de",
    "Studio 47"    => "Studio47.de",
    "WDR Aachen"    => "WDRAachen.de",
    "WDR Bielefeld"    => "WDRBielefeld.de",
    "WDR Bonn"    => "WDRBonn.de",
    "WDR Dortmund"    => "WDRDortmund.de",
    "WDR Duisburg"    => "WDRDuisburg.de",
    "WDR Düsseldorf"    => "WDRDuesseldorf.de",
    "WDR Essen"    => "WDREssen.de",
    "WDR Münster"    => "WDRMuenster.de",
    "WDR Siegen"    => "WDRSiegen.de",
    "WDR Wuppertal"    => "WDRWuppertal.de",
    "DRF1"    => "DRF1.de",
    "OK4"    => "OK4.de",
    "OK54 Trier"    => "OK54.de",
    "OK Weinstraße"    => "OKWeinstraße.de",
    "OK-TV Ludwigshafen"    => "OKTV-L.de",
    "OK:TV Mainz"    => "OKTV-M.de",
    "SAT.1 RhlPf Hessen"    => "Sat1RPHessen.de",
    "TV Mittelrhein"    => "TVM.de",
    "WWTV"    => "WWTV.de",
    "Chemnitz Fernsehen"    => "ChemnitzTV.de",
    "Dresden Fernsehen"    => "DresdenTV.de",
    "Leipzig Fernsehen"    => "LeipzigTV.de",
    "TV Westsachsen"    => "TVWestsachsen.de",
    "MDR Sachsen-Anhalt"    => "MDRS-Anhalt.de",
    "MDR Thüringen"    => "MDRThuringen.de",
    "Rennsteig.TV"    => "RennsteigTV.de",
    "salve.tv"    => "salvetv.de",
    "Sky 1"    => "Sky1.de",
    "SkyArts"    => "SkyArts.de",
    "SkyAtlantic"    => "SkyAtlanticHD.de",
    "Fox"    => "Fox.de",
    "Spiegel Geschichte (Sky)"    => "SpiegelGeschichte.de",
    "SkyKrimi"    => "SkyKrimi.de",
    "Classica (Sky)"    => "Classica.eu",
    "Jukebox (Sky)"    => "Jukebox.de",
    "Junior (Sky)"    => "Junior.de",
    "Penthouse"  => "Penthouse.ero",
    "Sky Cinema"    => "SkyCinema.de",
    "Sky Cinema +1"    => "SkyCinemaPlus1.de",
    "Sky Cinema +24"    => "SkyCinemaPlus24.de",
    "Sky Cinema Hits"    => "SkyCinemaHits.de",
    "Sky Cinema Monster"    => "SkyCinemaHits.de",
    "Sky Cinema Action"    => "SkyAction.de",
    "Sky Cinema Family"    => "SkyCinemaFamily.de",
    "Sky Cinema Comedy"    => "SkyComedy.de",
    "Sky Cinema Emotion"    => "SkyEmotion.de",
    "Sky Cinema Nostalgie"    => "SkyNostalgie.de",
    "Sky Sport Bundesliga 1"    => "SkyBundesliga.de",
    "Sky Sport Bundesliga 2"    => "SkyBundesliga2.de",
    "Sky Sport Bundesliga 3"    => "SkyBundesliga3.de",
    "Sky Sport Bundesliga 4"    => "SkyBundesliga4.de",
    "Sky Sport Bundesliga 5"    => "SkyBundesliga5.de",
    "Sky Sport Bundesliga 6"    => "SkyBundesliga6.de",
    "Sky Sport Bundesliga 7"    => "SkyBundesliga7.de",
    "Sky Sport Bundesliga 8"    => "SkyBundesliga8.de",
    "Sky Sport Bundesliga 9"    => "SkyBundesliga9.de",
    "Sky Sport Bundesliga 10"    => "SkyBundesliga10.de",
    "Sky Sport Austria"    => "SkySportAustria.de",
    "Sky Sport 1"    => "SkySport1.de",
    "Sky Sport 2"    => "SkySport2.de",
    "Sky Sport 3"    => "SkySport3.de",
    "Sky Sport 4"    => "SkySport4.de",
    "Sky Sport 5"    => "SkySport5.de",
    "Sky Sport 6"    => "SkySport6.de",
    "Sky Sport 7"    => "SkySport7.de",
    "Sky Sport 8"    => "SkySport8.de",
    "Sky Sport 9"    => "SkySport9.de",
    "Sky Sport 10"    => "SkySport10.de",
    "Sky Sport 11"    => "SkySport11.de",
    "13TH STREET (Sky)"    => "13thStreet.de",
    "BBC World"    =>  "BBCWorldNews.nws",
    "Beate-Uhse.TV (Sky)"    =>  "BeateUhse.de",
    "beIN Gurme"    => "beINGurme.fr",
    "beIN Movies Turk"    => "beINMoviesTurk.fr",
    "Blue Hustler"    => "BlueHustler.ero",
    "CNN International"    => "CNN.nws",
    "CNN Türk"    => "CNN.tr",
    "Discovery Channel (Sky)"    => "DiscoveryChannel.de",
    "Disney Cinemagic (Sky)"    => "DisneyCinemagic.de",
    "Disney Junior (Sky)"    => "DisneyJunior.de",
    "Disney XD (Sky)"    => "DisneyXD.de",
    "Dream Türk"    => "DreamTurk.tr",
    "E! Entertainment (Sky)"    => "EEntertainment.de",
    "Euro D"    => "EuroD.bg",
    "EuroN I"    => "EuronewsIT.nws",
    "EuroN RUS"    => "EuronewsRU.nws",
    "Eurosport 1 (Sky)"    => "Eurosport1.de",
    "Eurosport 2 (Sky)"    => "Eurosport2.de",
    "EURO STAR"    => "EUROSTAR.il",
    "Fox (Sky)"    => "FOX.de",
    "Heimatkanal (Sky)"    => "Heimatkanal.de",
    "HISTORY (Sky)"    => "History.de",
    "Instore TV"    => "Instore.tv",
    "iTVN"    => "iTVN.pl",
    "Kanal 7"    => "Kanal7.tr",
    "Kinomir"    => "Kinomir",
    "Kinowelt TV (Sky)"    => "Kinowelt.de",
    "Lokal-TV"    => "Lokal-TV",
    "L-TV"    => "L-TV",
    "Lust pur"    => "LustPur.de",
    "National Geographic (Sky)"    => "NatGeo.de",
    "National Geographic WILD (Sky)"    => "NatGeoWild.de",
    "Ost West"    => "Ost West",
    "Penthouse Passion"    => "PenthousePassion.ero",
    "Playboy Europe"    => "PlayboyEurope.ero",
    "Power Türk TV"    => "PowerTurk.tr",
    "Rai Due"    => "Rai2.it",
    "Rai Tre"    => "Rai3.it",
    "Rai Uno"    => "Rai1.it",
    "Romance TV (Sky)"    => "Romance.de",
    "RTR Planeta"    => "RTRPlaneta.pl",
    "Show Turk"    => "ShowTurk.tr",
    "Sky Cinema High Chaparral"    => "Sky Cinema High Chaparral",
    "Spiegel TV Wissen (Sky)"    => "SpiegelTV.de",
    "Syfy (Sky)"    => "SciFi.de",
    "T-Bom/T-Dom"    => "T-Bom/T-Dom",
    "TNT Comedy (Sky)"    => "TNTComedy.de",
    "TNT Film (Sky)"    => "TNTFilm.de",
    "TNT Serie (Sky)"    => "TNTSerie.de",
    "TV8 Int"    => "TV8.nws",
    "TV Polonia"    => "TVPolonia.pl",
    "Universal TV (Sky)" => "Universal.de",
    "maxdome"    => "maxdome",
    "Megathek"    => "Megathek",
    "Meine Aufnahmen"    => "Meine Aufnahmen",
    "Demokanal"    => "Demokanal",
    "Testkanal H01"    => "Testkanal H01",
    "Testkanal I01"    => "Testkanal I01",
    "Testkanal I03"    => "Testkanal I03",
    "Testkanal L01"    => "Testkanal L01",
    "Testkanal L02"    => "Testkanal L02",
    "Testkanal L03"    => "Testkanal L03",
    "Testkanal L04"    => "Testkanal L04",
    "Testkanal L05"    => "Testkanal L05",
    "Testkanal L06"    => "Testkanal L06",
    "Testkanal L07"    => "Testkanal L07",
    "Testkanal L08"    => "Testkanal L08",
    "Testkanal L09"    => "Testkanal L09",
 ) ;

my $PRE  = 'channel="' ;
my $POST = '">' ;

my $PREID  = 'channel id="' ;
my $POSTID = '">' ;

sub myfilter {
  my ($a) = @_;
  if ( exists $REPLACE{$a} ) {     
      return $REPLACE{$a} ;
  }else {
      print STDERR "Warning: Unmanaged channel: '$a'\n" ;
      return $a ;
   }
}

while (<>) {
    my $line = $_ ;
        $line =~ s/($PRE)(.*)($POST)/"$1".myfilter("$2")."$3"/ge ;
        $line =~ s/($PREID)(.*)($POSTID)/"$1".myfilter("$2")."$3"/ge ;
    print $line ;
}
